/* getpstr - get a string from input
 * string must be preceded by specified "prompt" text
 * return YES if text matched, NO otherwise
 */
#include "local.h"
#define FMTSIZE 84	/* arbitrary limit on size of "prompt" */

bool getpstr(p, s, n)
	char p[];				/* : !NULL */
	char s[];				/* : string */
	size_t n;				/* : {1:sizeof(p[*])} */
	{
	char buf[BUFSIZ];		/* : string */
	char fmt[FMTSIZE];		/* : string */
	metachar c;

	if (!strfit(fmt, p, FMTSIZE - 4))	/* copy "prompt" into fmt */
		return (NO);		/* prompt text is too long */
	strcat(fmt, "%s");		/* make fmt into a scanf format */
	while (isspace(c = getchar()))
		;					/* skip leading whitespace */
	ungetc(c, stdin);		/* put the non-whitespace back */
	if (scanf(fmt, buf) != 1)
		return (NO);		/* scanf match failed */
	if (!strfit(s, buf, n))
		fprintf(stderr, "<%s> chopped to <%s>\n", buf, s);
	return (YES);
	}
